#include <b.h>

#ifdef WIN32
#define TEST1_FILE ".\\TEST1"
#else
#define TEST1_FILE "/tmp/test1"
#endif

int
main (void)
{
  b_t *b;
  b_uint64 value;
  b_error_t err;

  fprintf (stderr, "Creating new b struct... ");
  if ((err = b_new (&b, (unsigned char *) TEST1_FILE)) != B_OK)
    {
      fprintf (stderr, "b_new: %s\n", b_strerror (err));
      return 1;
    }

  fprintf (stderr, "done.\nSetting the cache max to 16... ");
  b_set_max_cache (b, 16);

  fprintf (stderr, "done.\nGetting the cache max... ");
  b_get_max_cache (b, &value);

  fprintf (stderr, "%d.\nDestroing the b struct... ", (int) value);

  if ((err = b_destroy (b)) != B_OK)
    {
      fprintf (stderr, "b_destroy: %s\n", b_strerror (err));
      return 1;
    }

  fprintf (stderr, "done.\n");
  return 0;
}
