#include <b.h>

#define TEST2_MAX 1024

#ifdef WIN32
#define snprintf sprintf_s
#define TEST2_FILE ".\\TEST2"
#else
#define TEST2_FILE "/tmp/test2"
#endif


int
main (int argc, char **argv)
{
  b_t *b;
  int i, c, m;
  b_error_t err;

  fprintf (stderr, "Creating new b struct... ");
  if ((err = b_new (&b, (unsigned char *) TEST2_FILE)) != B_OK)
    {
      fprintf (stderr, "b_new: %s\n", b_strerror (err));
      return 1;
    }

  if (argc > 1 && (c = atoi (argv[1])))
    {
      fprintf (stderr, "done.\nSetting cache to %d... ", c);
      b_set_max_cache (b, c);
    }

  if (argc <= 2 || !(m = atoi (argv[2])))
    m = TEST2_MAX;

  fprintf (stderr, "done.\nStoring %d datas...", m);

  for (i = 0; i < m; i++)
    {
      char s[128];

      snprintf (s, sizeof (s), "test %d", i);

      if ((err =
	   b_add_type (b, B_TYPE_URI, (unsigned char *) s,
		       i % 2 ? 0 : strlen (s))) != B_OK)
	{
	  fprintf (stderr, "b_add: %s\n", b_strerror (err));
	  return 1;
	}
    }

  fprintf (stderr, "done.\nDestroing the b struct... ");

  if ((err = b_destroy (b)) != B_OK)
    {
      fprintf (stderr, "b_destroy: %s\n", b_strerror (err));
      return 1;
    }

  fprintf (stderr, "done.\n");
  return 0;
}
